/**
http_tool

	openssl Υ饤֥꤬󥹥ȡ뤵Ƥʤ֤ǤѤǤ褦ˡ
	https_tool Ȥ̤ˤʤäƤ롥

*/

#ifndef  _HTTP_TOOL_H
#define  _HTTP_TOOL_H



#include "tlist.h"
#include "txml.h"
#include "xtools.h"
#include "gz_tool.h"
#include "protocol.h"




#define	HTTP_CONNECTION_CLOSE	0
#define	HTTP_CONNECTION_KEEP	1
#define HTTP_HEADER_UNKNOWN_LEN	-1998
#define HTTP_HEADER_CHUNKED		-1999

#define PROXY_TIMEOUT  			10




int  	recv_http_header(int sock, tList** pl, int* len, FILE* fp, int* state);
int	 	send_http_header(int sock, tList*  pl, int mode);

int		recv_http_content(int sofd, Buffer* buf, int len, int tm, FILE* fp, int* state);
int  	recv_http_chunked(int sofd, Buffer* buf, int tm,  FILE* fp, int* state);

int 	recv_http_Buffer(int sock, tList** pl, Buffer* buf, int timeout, int* hdonly, int* state);
int 	send_http_Buffer(int sock, tList*  pl, Buffer* buf);

int	 	recv_http_file(int sock, tList** pl, const char* fn, const char* wdir, int timeout, int* hdonly, int* state);
int	 	send_http_file(int sock, tList*  pl, const char* fn);


int   	save_http_xml(int sock, tList** pl, tXML** xml, char** recvfn, const char* wdir, int timeout, int* state);



/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Tools
//
int  	decomp_url(Buffer url, Buffer* srvurl, Buffer* srvfqdn, unsigned short* sport, Buffer* srvdir);
void	set_host_header(tList* pl, char* hname, unsigned short hport);




/////////////////////////////////////////////////////////////////////////////////////////////////////////
// HTTP Proxy
//
void	simple_web_proxy(int bofd, char* myip, int tmout);
int  	www2browser_relay(int bofd, int wofd, int btm, int wtm, int keep);
Buffer  http_proxy_header_anlys(tList* pl, Buffer* server, unsigned short* sport, int* timeout, int* keep);



/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Alternative Tools
//
int		tcp_relay(int sofd, int cofd, int tm);



/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Server Side (Junk Code)
//
int	 	send_http_res_file(int sock, char* fn, int mode);
void 	send_http_passwd_req(int sock);




#endif 




